<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1bluetooth_implementations.html">bluetoothImplementations</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z.html">blueZ</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html">DBusProxy</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_d_bus_proxy_8h_source.html">DBusProxy.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_inherit__map" id="alexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_properties_proxy.html" title="alexaClientSDK::bluetooth\lImplementations::blueZ\l::DBusPropertiesProxy" alt="" coords="230,5,407,57"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1test_1_1_mock_d_bus_proxy.html" title="alexaClientSDK::bluetooth\lImplementations::blueZ\l::test::MockDBusProxy" alt="" coords="230,81,407,133"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a7ab2ebfdf203a7274750058fc77da362"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a7ab2ebfdf203a7274750058fc77da362">~DBusProxy</a> ()</td></tr>
<tr class="separator:a7ab2ebfdf203a7274750058fc77da362"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74615a82507e5bc8a253ce13e34246f9"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a74615a82507e5bc8a253ce13e34246f9">callMethod</a> (const std::string &amp;methodName, GVariant *parameters=nullptr, GError **error=nullptr)</td></tr>
<tr class="separator:a74615a82507e5bc8a253ce13e34246f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb7a0400c211451c3563a56cf7f3492d"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#afb7a0400c211451c3563a56cf7f3492d">callMethodWithFDList</a> (const std::string &amp;methodName, GVariant *parameters=nullptr, GUnixFDList **outlist=nullptr, GError **error=nullptr)</td></tr>
<tr class="separator:afb7a0400c211451c3563a56cf7f3492d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a20347ff0cf0cbe3890ddc18c570026e7"><td class="memItemLeft" align="right" valign="top">virtual std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a20347ff0cf0cbe3890ddc18c570026e7">getObjectPath</a> () const</td></tr>
<tr class="separator:a20347ff0cf0cbe3890ddc18c570026e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa87f575cbcb462863edcbf83177ca969"><td class="memItemLeft" align="right" valign="top">virtual GDBusProxy *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#aa87f575cbcb462863edcbf83177ca969">get</a> ()</td></tr>
<tr class="separator:aa87f575cbcb462863edcbf83177ca969"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a66fc1cf41f434b017ac93e5407855a40"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html">DBusProxy</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a66fc1cf41f434b017ac93e5407855a40">create</a> (const std::string &amp;interfaceName, const std::string &amp;objectPath)</td></tr>
<tr class="separator:a66fc1cf41f434b017ac93e5407855a40"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a290d683d76dce5e7a0e14873f638ae0b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a290d683d76dce5e7a0e14873f638ae0b">DBusProxy</a> (GDBusProxy *proxy, const std::string &amp;objectPath)</td></tr>
<tr class="separator:a290d683d76dce5e7a0e14873f638ae0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">A wrapper class for DBus proxy objects. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a7ab2ebfdf203a7274750058fc77da362"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7ab2ebfdf203a7274750058fc77da362">&#9670;&nbsp;</a></span>~DBusProxy()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::~DBusProxy </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a290d683d76dce5e7a0e14873f638ae0b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a290d683d76dce5e7a0e14873f638ae0b">&#9670;&nbsp;</a></span>DBusProxy()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::DBusProxy </td>
          <td>(</td>
          <td class="paramtype">GDBusProxy *&#160;</td>
          <td class="paramname"><em>proxy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>objectPath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Constructor that initializes the object with an existing <code>GDBusProxy*</code> value. It also receives object path for the object being proxified to keep it for later use.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">proxy</td><td>An existing <code>GDBusProxy*</code> value </td></tr>
    <tr><td class="paramname">objectPath</td><td>Object path of an object being proxified </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a74615a82507e5bc8a253ce13e34246f9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74615a82507e5bc8a253ce13e34246f9">&#9670;&nbsp;</a></span>callMethod()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a> alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::callMethod </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>methodName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GVariant *&#160;</td>
          <td class="paramname"><em>parameters</em> = <code>nullptr</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GError **&#160;</td>
          <td class="paramname"><em>error</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Calls a method of the proxy and returns the its result.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">methodName</td><td>Name of the method to invoke </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">parameters</td><td>A <code>GVariant*</code> containing the tuple with the parameters for the method or nullptr if method does not have any parameters </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">error</td><td>A pointer to a <code>GError*</code> variable that will receive the error returned by method invocation </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The result <code>GVariant*</code> returned by method invocation </dd></dl>

</div>
</div>
<a id="afb7a0400c211451c3563a56cf7f3492d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afb7a0400c211451c3563a56cf7f3492d">&#9670;&nbsp;</a></span>callMethodWithFDList()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a> alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::callMethodWithFDList </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>methodName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GVariant *&#160;</td>
          <td class="paramname"><em>parameters</em> = <code>nullptr</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GUnixFDList **&#160;</td>
          <td class="paramname"><em>outlist</em> = <code>nullptr</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GError **&#160;</td>
          <td class="paramname"><em>error</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Calls a method of the proxy and returns the its result along with the list of linux file descriptors associated with it.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">methodName</td><td>Name of the method to invoke </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">parameters</td><td>A <code>GVariant*</code> containing the tuple with the parameters for the method or nullptr if method does not have any parameters </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">outlist</td><td>A pointer to <code>GUnixFDList*</code> variable that recieves a list of linux file descriptor list associated with result returned by the method call </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">error</td><td>A pointer to a <code>GError*</code> variable that will receive the error returned by method invocation </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The result <code>GVariant*</code> returned by method invocation </dd></dl>

</div>
</div>
<a id="a66fc1cf41f434b017ac93e5407855a40"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a66fc1cf41f434b017ac93e5407855a40">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html">DBusProxy</a> &gt; alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::create </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>interfaceName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>objectPath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Factory method to create a new instance of the DBus proxy. DBus proxies are shortcuts that bind to a specific interface of an object and simplifies operations on that object by avoiding providing the object and its interface during the subsequent calls.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">interfaceName</td><td>Name of the DBus interface to be proxified </td></tr>
    <tr><td class="paramname">objectPath</td><td>Object path to an object who's interface is to be proxified </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A new instance of <code><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html">DBusProxy</a></code> on success, nullptr otherwise. </dd></dl>

</div>
</div>
<a id="aa87f575cbcb462863edcbf83177ca969"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa87f575cbcb462863edcbf83177ca969">&#9670;&nbsp;</a></span>get()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">GDBusProxy * alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::get </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Get the raw <code>GDBusProxy*</code> value associated with the object</p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to <code>GDBusProxy</code> object associated with the this instance. This pointer is valid as long as <code><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html">DBusProxy</a></code> object is valid. </dd></dl>

</div>
</div>
<a id="a20347ff0cf0cbe3890ddc18c570026e7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a20347ff0cf0cbe3890ddc18c570026e7">&#9670;&nbsp;</a></span>getObjectPath()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::getObjectPath </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Get the path of the object being proxified</p>
<dl class="section return"><dt>Returns</dt><dd>A string containing the object path </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/BluetoothImplementations/BlueZ/include/BlueZ/<a class="el" href="_d_bus_proxy_8h_source.html">DBusProxy.h</a></li>
<li>/workplace/avs-device-sdk/BluetoothImplementations/BlueZ/src/<a class="el" href="_d_bus_proxy_8cpp.html">DBusProxy.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
